*xxtest.prg 
*This programme is a simple demonstration of 'xxbrowse'.
*Gordon Angus 1 November 1994

*it demonstrates:
* 1. The size and title parameters
* 2. The ability to use normal browse commands (used here: 'FIELDS' 
*    and 'TITLE')
* 3. The use of the browse field modifiers to interact with the displays
* 4. Embedded functions/procedures :
*		a. inchis which chisels an edge around a field
*		b. gobrowse which transfers control from the top screen back to
*		   the browse screen.
*		c. dgbox which is a simple 3D dialog box
* 5. The addition of objects to the control window using "PROCEDURE tw_xxxx"
* 6. The use of "PROCEDURE ok_xxxx"  to perform update/backup tasks





*include xxbrowse procedure set
SET PROCEDURE TO xxbrowse.prg

*define variables
prnt=1
updateflg=.F.
xxsafety=SET('SAFETY')

*establish database for browse and back it up
SELECT * FROM xxtest INTO TABLE xxtestbk.dbf
SELECT xxtest
GO TOP


**XXBROWSE as FULL PAGE

*call xxbrowse as a full page item (.. with 0,..,0,..)
DO xxbrowse WITH 0,0,0,'Top Title','Bottom Line','Title "Browse Title" ;
   FIELDS supp_code:W=.F., sup_inv_no:W=winvamt():F:v=vsupp(),;
   descript:W=vsupp(), inhouse_no:W=.F., qty_pd:W=winvamt(),;
   cst_ea_usd:W=winvamt(), date_pd:W=.F., amount:W=.F.,;
   order_no:W=.F., pmnt_no:W=.f.'


*if update flag not set then restore from backup
IF NOT updateflg
   SET SAFETY OFF
   SELECT * FROM xxtestbk INTO TABLE xxtest.dbf
   SET SAFETY &xxsafety
ENDIF



*reset update flag
updateflg=.F.





**XXBROWSE as PART PAGE

*repeat xxbrowse but as a part page
DO xxbrowse WITH 30,12,70,'Example of Re-sized Window','Bottom Line',;
   'TITLE "split is upper edge of this browse window" ;
   FIELDS supp_code:W=.F., sup_inv_no:W=winvamt(),;
   descript:W=winvamt(), inhouse_no:W=.F., qty_pd:W=winvamt(),;
   cst_ea_usd:W=winvamt(), date_pd:W=.F., amount:W=.F.,;
   order_no:W=.f.'

*if update flag not set then restore from backup
IF NOT updateflg
   SET SAFETY OFF
   SELECT * FROM xxtestbk INTO TABLE xxtest.dbf
   SET SAFETY &xxsafety
ENDIF





*cleanup and finish
SELECT xxtest
USE
SELECT xxtestbk
USE
SET SAFETY OFF
ERASE xxtestbk.dbf
SET SAFETY &xxsafety
RETURN






********Procedures and Functions********
*Control window objects (@...gets etc.) for 1st browse.
*(Title of browse is  "Browse Title", therefore the procedure name
*is TW_BROWS[e title])
PROCEDURE tw_brows

*demonstrate the addition of a push button control
@ 4,57 GET prnt FUNCTION '*HN Print/Preview' SIZE 2,15;
   FONT 'ms sans serif',8 STYLE 'b' VALID vprnt()

RETURN

************
*Control window for 2nd browse ("split is upper ...")
PROCEDURE tw_split
*add @..gets, @..says here.
RETURN

************
*update procedure for 1st browse
PROCEDURE ok_brows
updateflg=.T.
WAIT WINDOW NOWAIT 'Now running update procedure for 1st browse'
RETURN

************
*update procedure for 2nd browse
PROCEDURE ok_split
WAIT WINDOW NOWAIT '2nd browse - Update Procedure'
RETURN

************
*monitor invoice details
FUNCTION vsupp
*recalc invoice amount
=winvamt()

*require entry of an invoice number if none exists
IF sup_inv_no=' '
   @ 3,WCOLS()-50 SAY 'Enter Invoice No.:' FONT 'ms sans serif',8 STYLE 'b'

   *chisel edges of '@..get'
   DO inchis WITH 3,WCOLS()-25,1,14
   @ 3,WCOLS()-25 GET sup_inv_no PICTURE '@!K' SIZE 1,14 COLOR ,N/BG* VALID vsuprd()
   READ
   @ 2.5,WCOLS()-50 say' ' size 2,40

   *return control to browse
   DO gobrowse
ENDIF
RETURN


************
*prevent exit from field if invoice number not supplied
FUNCTION vsuprd
IF sup_inv_no='   '
   RETURN .F.
ENDIF
RETURN


************
*recalc invoice amount
FUNCTION winvamt
lcsin=sup_inv_no
lcsc=supp_code

*calculate invoice total
SELECT SUM(qty_pd*cst_ea_usd) AS invamt FROM xxtest;
   WHERE supp_code=lcsc AND sup_inv_no=lcsin INTO CURSOR sinvamt

*calculate total of all invoices for this vendor
SELECT SUM(qty_pd*cst_ea_usd) AS tinvamt FROM xxtest;
   WHERE supp_code=lcsc INTO CURSOR sinv

*display results in general data entry window
@ 3,5 SAY 'Total this Invoice ('+ALLTRIM(lcsin)+'):' SIZE 1,33
@ 5,5 SAY 'Total all invoices for Supplier:' SIZE 1,30
DO inchis WITH 3,40,1,14
@3,40 SAY sinvamt.invamt COLOR N/G* SIZE 1,14
DO inchis WITH 5,40,1,14
@5,40 SAY sinv.tinvamt COLOR N/G* SIZE 1,14

SELECT xxtest
RETURN


************
FUNCTION vprnt
DO dgbox WITH 10,60,'Print/Preview',;
   'No Printout - You need to Define your own Report Form'
@ 6,40 GET xprnt DEFAULT 1 FUNCTION '*H OK' ;
   FONT 'ms sans serif',8 STYLE 'b' SIZE 2,10
READ
RELEASE WINDOW dgbox
RETURN
